@ECHO off
REM Installation for MC interim fix
REM RenLei 07-01-26
REM you have to set the following variable
REM according to your system

SET SILENT=false
IF "%1a"=="a" GOTO no_param
IF NOT EXIST %1\License ECHO ****** Could not find directory %1\License ******
IF NOT EXIST %1\License GOTO no_param
SET ITM_HOME=%1
IF NOT "%2a"=="a" SET SILENT=true
GOTO checkPrerequisite

:no_param
ECHO You did not specify your ITM installation path
ECHO Try to use the default one - C:\IBM\ITM
set ITM_HOME=C:\IBM\ITM
IF not EXIST %ITM_HOME%\License  ECHO Could not find directory %ITM_HOME%\License, press any key ...
IF not EXIST %ITM_HOME% GOTO queryITM
ECHO Would you confirm the default location '%ITM_HOME%' is the right place for install? (Y/N)
SET /P useDefaultITM=
IF /I "%useDefaultITM%"=="y" goto checkPrerequisite

:queryITM
pause
ECHO Please input your ITM folder:
SET /P ITM_HOME=
IF not EXIST %ITM_HOME%\License  ECHO Could not find directory %ITM_HOME%\License
IF not EXIST %ITM_HOME%\License  GOTO queryITM
GOTO checkPrerequisite

:checkPrerequisite
%ITM_HOME%\InstallITM\KinCInfo.exe -i > info
echo CF >comp
echo IC >>comp
echo IE >>comp
echo MC >>comp
echo MQ >>comp
echo QI >>comp
set MyVar=
setlocal ENABLEDELAYEDEXPANSION
FOR /F  %%j IN (comp) DO (
	FIND "%%j    " <info >match
	set /p MyVar= <match
	IF NOT "!MyVar!a"=="a" goto getMsgVersion 
)

:getMsgVersion
set FOUND=
set VER=
FOR /F "delims=!" %%i IN (info) DO (if  "%MyVar%" == "%%i" ( set FOUND=123) ELSE ( if "!FOUND!" == "123" SET FOUND=%%i ))
ECHO !FOUND! >version
FOR /F "tokens=3 delims= " %%i IN (version) DO SET VER=%%i
SET "VER=%VER:.=%"
SET "VER=%VER: =%"
SET VER=%VER:~0,-2%
@del /Q version
@del /Q match
@del /Q comp

set /p PREREQ= < prerequisite
IF NOT "%VER%"=="%PREREQ%" echo The current version is %VER%, the prerequisite is %PREREQ%%, can not install this patch
IF NOT "%VER%"=="%PREREQ%" goto endpro

:genUninstall
SET uninst=patch_uninstall.bat
SET missed=no
IF EXIST %uninst% DEL %uninst%
IF EXIST backup RD /s /q backup
MD backup
MD backup\InstallITM
MD backup\InstallITM\ver

SET ITMVER=
IF NOT EXIST %ITM_HOME%\InstallITM\ver (ECHO ******CAN NOT FIND VERSION INFO******)
echo MS >comp
echo CW >>comp
echo CJ >>comp
echo CQ >>comp
echo GL >>comp
echo OS >>comp
echo UA >>comp
set MyVar=
setlocal ENABLEDELAYEDEXPANSION
FOR /F  %%j IN (comp) DO (
	FIND "%%j    " <info >match
	set /p MyVar= <match
	IF NOT "!MyVar!a"=="a" goto getITMVersion 
)

:getITMVersion
set FOUND=
set VER=
FOR /F "delims=!" %%i IN (info) DO (if  "%MyVar%" == "%%i" ( set FOUND=123) ELSE ( if "!FOUND!" == "123" SET FOUND=%%i ))
ECHO %FOUND% >info
FOR /F "tokens=2 delims=." %%i IN (info) DO SET VER=%%i
IF "%VER%" == "20" SET ITMVER=ITM62
IF "%VER%" == "10" SET ITMVER=ITM61
@del /Q info
@del /Q match
@del /Q comp
IF "%ITMVER%" == "" ECHO ---------CANNOT GET ITM VERSION INFO-------
IF "%ITMVER%" == "" GOTO endpro

ECHO %ITMVER% is found under %ITM_HOME% 
IF EXIST %ITMVER%\file_list.txt TYPE %ITMVER%\file_list.txt >>file_list.txt
move file_list.txt file_list.txt.bak
@XCOPY /E /Y %ITMVER%\* .
move file_list.txt.bak file_list.txt

SET KMQAGENT=false
SET KQIAGENT=false
SET KMCAGENT=false
IF EXIST %ITM_HOME%\TMAITM6\kmqagent.exe (SET KMQAGENT=true)
IF EXIST %ITM_HOME%\TMAITM6\kqiagent.exe (SET KQIAGENT=true)
IF EXIST %ITM_HOME%\TMAITM6\kmcrca.exe   (SET KMCAGENT=true)

ECHO Backup old files first
IF NOT "%SILENT%"=="true" PAUSE
@XCOPY /E /I CNB backup\CNB
@XCOPY /E /I CNP backup\CNP
@XCOPY /E /I CNPS backup\CNPS
@XCOPY /E /I CMS backup\CMS
@XCOPY /E /I TMAITM6 backup\TMAITM6
@XCOPY /E /I InstallITM backup\InstallITM
@XCOPY /E /I Config backup\Config
FOR /F %%i IN (file_list.txt) DO ( IF EXIST %ITM_HOME%\%%i ( @xcopy /I /E /Y %ITM_HOME%\%%i backup\%%i ) ELSE ( SET missed=yes ) )
REM BACKUP VERSION FILES
FOR /F %%i IN (version_files.txt) DO ( IF EXIST %ITM_HOME%\%%i ( @copy /V /Y %ITM_HOME%\%%i backup\%%i ) )
ECHO Generate uninstall
IF NOT "%SILENT%"=="true" PAUSE
ECHO rem This is generated by patch_install.bat > %uninst%
ECHO rem This batch file could retore your original modules from an interim fix installation >> %uninst%
ECHO rem Please do not modify this file >> %uninst%
FOR /F %%i IN (file_list.txt) DO ( IF EXIST %ITM_HOME%\%%i ( ECHO XCOPY /Y backup\%%i %ITM_HOME%\%%i >> %uninst% ) )

REM Restore agent instances files
IF "%KMQAGENT%"=="true" ( ECHO ctrlagent.exe update kmq -a %ITM_HOME% >> %uninst%)
IF "%KQIAGENT%"=="true" ( ECHO ctrlagent.exe update kqi -a %ITM_HOME% >> %uninst%)

REM UNINSTALL VERSION FILES
FOR /F %%i IN (version_files.txt) DO ( IF EXIST %ITM_HOME%\%%i ( ECHO COPY /Y /V backup\%%i %ITM_HOME%\%%i >> %uninst% ) )
SET dependency=
SETLOCAL EnableDelayedExpansion
FOR /F %%i IN (new_files.txt) DO (
	IF NOT "%%i"=="--" (
		IF "!dependency!"=="" (
			IF EXIST %ITM_HOME%\%%i (
				SET dependency=yes
			) ELSE (
				SET dependency=no
			)
		) ELSE (
			IF "!dependency!"=="yes" (
				ECHO DEL /Q %ITM_HOME%\%%i >> %uninst%
			)
			
		)
	) ELSE (
		SET dependency=
	)
)
ENDLOCAL
GOTO startInst


:startInst
set i=
ECHO We are going to install the interim fix to the directory %ITM_HOME%
ECHO If you don't want that, 
ECHO or IF this is not correct, press CTRL-BREAK now,
IF NOT "%SILENT%"=="true" PAUSE
ECHO Ok, we're going...

FOR /F %%i IN (file_list.txt) DO ( IF EXIST %ITM_HOME%\%%i ( @xcopy /Y %%i %ITM_HOME%\%%i ) ELSE ( SET missed=yes ) )
SET dependency=
SETLOCAL EnableDelayedExpansion
FOR /F %%i IN (new_files.txt) DO (
	IF NOT "%%i"=="--" (
		IF "!dependency!"=="" (
			IF EXIST %ITM_HOME%\%%i (
				SET dependency=yes
			) ELSE (
				SET dependency=no
			)
		) ELSE (
			IF "!dependency!"=="yes" (
				ECHO %%i
				@COPY /Y %%i %ITM_HOME%\%%i 
			)
		)
	) ELSE (
		SET dependency=
	)
)
ENDLOCAL
goto replace

:replace
REM version files update from 06010100 to 06010101
set oldver="VRMF=06010100"
set newver="VRMF=06010101"
FOR /F %%i IN (version_files.txt) DO (
	IF EXIST %ITM_HOME%\%%i (
		replace %ITM_HOME%\%%i tmp %oldver% %newver%
		if "!errorlevel!" == "1" (
			@copy /Y /V  tmp %ITM_HOME%\%%i
			
		)
		@del /Q tmp
	)
)

goto result

:result
set i=
echo *************************************************************
echo *************************************************************
IF %missed%==yes ECHO Below file(s) were not copied during this installation.
IF %missed%==yes ECHO Because they do not exist in your directory, probably you did not install the related component, it is normal
IF %missed%==yes ECHO This is normal.
IF %missed%==yes ( For /F %%i IN (file_list.txt) DO ( IF NOT EXIST %ITM_HOME%\%%i ECHO %%i ) )
IF %missed%==yes ECHO *************************************************************
IF %missed%==yes ECHO *************************************************************

REM ECHO Sync with agent instances
IF "%KMQAGENT%"=="true" ( ctrlagent.exe update kmq -a %ITM_HOME% )
IF "%KQIAGENT%"=="true" ( ctrlagent.exe update kqi -a %ITM_HOME% )

ECHO Install complete
goto endpro

rem :errorend
rem ECHO ERROR! Program is ending ...
rem GOTO endpro

:endpro
